using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Xna.Framework;

namespace BasicEditor
{
    public class Map
    {
       // internal protected Rectangle playArea = new Rectangle(0, 0, 480, 480);
        internal protected Block[,] blocks;
        internal protected float blockWidth = 16;
        internal protected float blockHeight = 16;
        internal protected int mapWidth = 20;
        internal protected  int mapHeight = 10;
        internal string mapTitle;
        internal protected bool needsToBeInit = true;


        public bool NeedsToBeInitilized
        {
            get { return needsToBeInit; }
        }

        public string MapTitle
        {
            get { return mapTitle; }
            set { mapTitle = value; }
        }
	
        public float BlockWidth
        {
            get { return blockWidth; }
           // set { blockWidth = value; }
        }

        public float BlockHeight
        {
            get { return blockHeight; }
           // set { blockHeight = value; }
        }

        public int MapWidth
        {
            get { return mapWidth; }
            set
            {
                mapWidth = value;
                this.needsToBeInit = true;
            }
        }

        public int MapHeight
        {
            get { return mapHeight; }
            set { 
                mapHeight=value;
                this.needsToBeInit = true;
            }
        }

        //public Rectangle PlayArea
        //{
        //    get { return PlayArea; }
        //    set { playArea = value; }
        //}

        //public int PlayAreaLeft
        //{
        //    get { return PlayArea.X; }
        //    set { playArea.X = value; }
        //}

        //public int PlayAreaTop
        //{
        //    get { return PlayArea.Y; }
        //    set { playArea.Y = value; }
        //}

        //public int PlayAreaWidth
        //{
        //    get { return PlayArea.Width; }
        //    set { playArea.Width = value; }
        //}

        //public int PlayAreaHeight
        //{
        //    get { return PlayArea.Height; }
        //    set { playArea.Height = value; }
        //}

        public Map()
        {
            this.Initilize();
        }

        public void Initilize()
        {
            // TODO: need to add option for preserving existing block data
           // mapWidth = (int)(playArea.Width / blockWidth);
            //mapHeight = (int)(playArea.Height / blockHeight);
            blocks = new Block[mapWidth, mapHeight];  
        }
                  
        public Block GetBlock(int x, int y)
        {
            return blocks[x, y]; 
        }

        public void SetBlock(int x, int y, Block value)
        {
            if (x < 0 || x > this.mapWidth - 1) { return; }
            if (y < 0 || y > this.mapHeight - 1) { return; }
            blocks[x, y] = value;
        }

        public void Resize(int w, int h)
        {
            this.mapWidth = w;
            this.mapHeight = h;
            this.needsToBeInit = true;
        }
    }
}
