
#region Using Statements
using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
#endregion

namespace BasicEditor.Components
{
    /// <summary>
    /// This is a game component that implements IUpdateable.
    /// </summary>
    public partial class GUIRenderer : Microsoft.Xna.Framework.DrawableGameComponent
    {
        private System.Collections.Generic.Dictionary<string, Interfaces.IGUIWidget> desktop = new Dictionary<string, Interfaces.IGUIWidget>();
        internal protected SpriteBatch sb;
        internal protected Editor editor;
        internal protected xFrippery.xFrippery inputHandler = new xFrippery.xFrippery();

        public void DoMouseDown()
        {
            inputHandler.Controls = this.desktop.Values;
            inputHandler.DoMouseDown(this, xFrippery.MouseButtons.None, Vector2.Zero);

            foreach (Interfaces.IGUIWidget w in this.desktop)
            {
                
            }
        }

        public System.Collections.Generic.Dictionary<string, Interfaces.IGUIWidget> Desktop
        {
            get { return desktop; }
        }

        public GUIRenderer(Editor game)
            : base(game)
        {
            // TODO: Construct any child components here
            this.editor = game;
        }


        /// <summary>
        /// Allows the game component to perform any initialization it needs to before starting
        /// to run.  This is where it can query for any required services and load content.
        /// </summary>
        public override void Initialize()
        {
            // TODO: Add your initialization code here

            base.Initialize();
            sb = new SpriteBatch(this.GraphicsDevice);
        }


        /// <summary>
        /// Allows the game component to update itself.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        public override void Update(GameTime gameTime)
        {
            // update widgets
            foreach (string key in this.desktop.Keys)
            {
                this.desktop[key].Update(this.editor, gameTime);
            }

            base.Update(gameTime);
        }

        /// <summary>
        /// Allows the game component to draw itself.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        public override void Draw(GameTime gameTime)
        {
            // TODO: Add your draw code here
            sb.Begin(SpriteBlendMode.AlphaBlend);
            foreach (string key in this.desktop.Keys)
            {
                this.desktop[key].Draw(gameTime, this.sb);// DrawControl(this.desktop[key], true);
            }
            sb.End();

            base.Draw(gameTime);
        }

        //void DrawChildren(xFrippery.ControlCollection controls, bool drawChildren)
        //{
        //    foreach (xFrippery.Control c in controls)
        //    {
        //        DrawControl(c, drawChildren);
        //    }
        //}

        //void DrawControl(xFrippery.Control c, bool drawChildren)
        //{
        //    if (c == null) { return; }
        //    if (!c.Visible) { return; }

        //    Rectangle sr;
        //    string tex = string.Empty;

        //    // extract texture to use
        //    tex = ExtractData(c.Data, "texture");

        //    // draw if texture exists
        //    if (this.editor.guiTextures.ContainsKey(tex))
        //    {
        //        // extract source texture rect
        //        if (!int.TryParse(ExtractData(c.Data, "sourceleft"), out sr.X))
        //        {
        //            return;
        //        }
        //        if (!int.TryParse(ExtractData(c.Data, "sourcetop"), out sr.Y))
        //        {
        //            return;
        //        }
        //        if (!int.TryParse(ExtractData(c.Data, "sourcewidth"), out sr.Width))
        //        {
        //            return;
        //        }
        //        if (!int.TryParse(ExtractData(c.Data, "sourceheight"), out sr.Height))
        //        {
        //            return;
        //        }

        //        // calc dest rect
        //        Rectangle dr;
        //        Vector2 v;
        //        if (c.Parent != null)
        //        {
        //            v = c.Parent.PointToScreen(new Vector2(c.Left, c.Top));
        //        }
        //        else
        //        {
        //            v = new Vector2(c.Left, c.Top);
        //        }
        //        dr.X = (int)v.X;
        //        dr.Y = (int)v.Y;
        //        //v = c.PointToScreen(new Vector2(c.Left + c.Width, c.Top + c.Width));
        //        //dr.Right = (int)v.X;
        //        //dr.Bottom = (int)v.Y;
        //        dr.Width = c.Width;
        //        dr.Height = c.Height;

        //        // draw control
        //        sb.Draw(this.editor.guiTextures[tex], dr, sr, Color.White);
        //    }

        //    if (drawChildren) { DrawChildren(c.Children, drawChildren); }
        //}

        //string ExtractData(string data, string e)
        //{
        //    string tmp = "<" + e + ">";
        //    if (data.IndexOf(tmp) != -1)
        //    {
        //        data = data.Substring(data.IndexOf(tmp) + tmp.Length);
        //        data = data.Substring(0, data.IndexOf("<"));
        //        return data;
        //    }
        //    return string.Empty;
        //}

    }
}


