using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;

namespace xFrippery
{
    public delegate void ClickEventHandler(object sender);
    public delegate void MouseDownEventHandler(object sender, MouseButtons b, Vector2 pos);
    public delegate void MouseMoveEventHandler(object sender, MouseButtons b, Vector2 pos);
    public delegate void MouseUpEventHandler(object sender, MouseButtons b, Vector2 pos);
    public delegate void KeyUpEventHandler(object sender, Keys e);
    public delegate void KeyDownEventHandler(object sender, Keys e);
    public delegate void KeyClickEventHandler(object sender, Keys e);
    public delegate void WidthEventHandler(object sender, int value, int oldvalue);
    public delegate void HeightEventHandler(object sender, int value, int oldvalue);
    public delegate void BoundsEventHandler(object sender, Rectangle value, Rectangle oldvalue);

    public interface IControl: ICloneable 
    {
        IControl GetControlFromPoint(float X, float Y);
        AnchorStyles Anchor { get; set; }   
        int Height { get; set; }                                   
        int Width { get; set; }                                    
        int Top { get; set; }                                      
        int Left { get; set; }                                     
        Rectangle Bounds { get; set; }                             
        Vector2 PointToScreen(Vector2 Pt);            
        Vector2 PointToClient(Vector2 Pt);            
        void MoveToFront();
        void MoveToBack(); 
        string Data { get; set; }       
        string Name { get; set; }       
        void DoMouseDown(object sender, MouseButtons b, Vector2 pos);
        void DoMouseMove(object sender, MouseButtons b, Vector2 pos);
        void DoMouseUp(object sender, MouseButtons b, Vector2 pos);
        void DoClick(object sender, MouseButtons b, Vector2 pos);
        ControlCollection Children { get; set; }
        IControl Parent { get; set; }
        bool Visible { get; set; }
     
        event ClickEventHandler Click;
        event MouseDownEventHandler MouseDown;
        event MouseMoveEventHandler MouseMove;
        event MouseUpEventHandler MouseUp;
        event KeyUpEventHandler KeyUp;
        event KeyDownEventHandler KeyDown;
        event KeyClickEventHandler KeyClick;
        event WidthEventHandler WidthChanged;
        event HeightEventHandler HeightChanged;
        event BoundsEventHandler BoundsChanged;
    }
}
